<?php

namespace Picea\Caching;

class Opcache {

    protected string $cachePath = "";

    public function __construct(string $cachePath)
    {
        $this->cachePath = $cachePath;
    }

    public function loadFile(string $fileName) : bool
    {
        if ( file_exists($path = $this->filePath($fileName)) ) {
            require_once($path);
            return true;
        }

        return false;
    }

    public function saveFile(string $fileName, string $content) : bool
    {
        file_put_contents($this->filePath($fileName), $content);

        return false;
    }

    public function filePath(string $fileName) : string
    {
        return $this->cachePath . $fileName;
    }
}
